<template>
    <app-layout>
        <div class="row justify-content-center">
            <div class="col-lg-6">
                <h1 class="h2 mb-3">{{ group.name }}</h1>
                
                <form @submit.prevent="submit(route('server.skins.groupUpdate', group))">
                    <table class="table table-hover">
                        <thead>
                            <tr class="table-dark">
                                <th scope="col">GUID</th>
                                <th scope="col">Name</th>
                                <th scope="col">Remove?</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="player in players" :key="player.id">
                                <td>
                                    <inertia-link :href="route('players.get', player)" class="text-decoration-none d-block">
                                        {{ player.id }}
                                    </inertia-link>
                                </td>
                                <td>{{ player.name }}</td>
                                <td class="table-danger">
                                    <input type="checkbox" class="form-check-input" @input="setKeepPlayer(player.id, !$event.target.checked)" />
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    
                    <form-list-input text="New Players" :list="this.form.newPlayers" :errors="form.errors" errorPrefix="newPlayers" placeholder="GUID" />
                    
                    <form-button :disabled="form.processing">Save Changes</form-button>
                    <inertia-link class="btn btn-danger ms-2" as="button" type="button" :href="route('server.skins.groupDelete', group)" method="delete">Delete Group</inertia-link>
                </form>
            </div>
        </div>
    </app-layout>
</template>

<script>
    import { useForm } from '@inertiajs/inertia-vue3'
    import AppLayout from '@/Layouts/AppLayout'
    import FormListInput from '@/Components/Form/FormListInput'
    import FormButton from '@/Components/Form/FormButton'
    
    export default {
        props: {
            'group': Object,
            'players': Array,
        },
        
        components: {
            AppLayout,
            FormListInput,
            FormButton,
        },
        
        mounted() {
            for (const player of this.players) {
                this.form.oldPlayers.push(player.id)
            }
        },
        
        methods: {
            setKeepPlayer(id, keep) {
                const idIndex = this.form.oldPlayers.indexOf(id)
                
                if (idIndex > -1) {
                    if (!keep) {
                        this.form.oldPlayers.splice(idIndex, 1)
                    }
                } else {
                    if (keep) {
                        this.form.oldPlayers.push(id)
                    }
                }
            }
        },
        
        setup () {
            const form = useForm({
                newPlayers: [],
                oldPlayers: [],
            })
            
            function submit(path) {
                form.patch(path, {
                    preserveState: (page) => Object.keys(page.props.errors).length,
                })
            }
            
            return { form, submit }
        },
    }
</script>